<?php

namespace Codemanas\WooPreviewEmailsPro\Admin;

class NoticeHandler {
	public static string $message = '';
	public static string $message_type = 'warning';
	public static bool $is_dismissible = false;
	private static ?NoticeHandler $_instance = null;

	public static function get_instance(): ?NoticeHandler {
		return ( self::$_instance == null ) ? self::$_instance = new self() : self::$_instance;
	}

	public function __construct() {
		add_action( 'admin_notices', [ $this, 'maybe_show_notice' ] );
	}

	public static function set_message( $message, $message_type, $is_dismissible ) {
		self::$message      = $message;
		self::$message_type = $message_type;
        self::$is_dismissible = $is_dismissible;
	}

	public function maybe_show_notice() {
		if ( self::$message == '' ) {
			return;
		}

		$classes = [ 'notice' ];

		switch ( self::$message_type ) {
			case 'error':
				$classes[] = 'notice-error';
				break;
			case 'warning':
				$classes[] = 'notice-warning';
				break;
			case 'success':
				$classes[] = 'notice-success';
		}

		$classes[] = self::$is_dismissible ? 'is-dismissible' : '';

		?>
        <div class="<?php echo implode( ' ', $classes ) ?>"><?php echo wp_kses( self::$message, [
				'div' => [],
				'a'   => [],
				'p'   => [],
                'strong' => []
			],
	        ); ?></div>
		<?php

	}
}