<?php

namespace Codemanas\WooPreviewEmailsPro\WooCommerce;

final class Main {
	private static ?Main $_instance = null;

	public static function get_instance(): ?Main {
		return ( self::$_instance == null ) ? self::$_instance = new self() : self::$_instance;
	}

	private function __construct() {
		add_action( 'before_woocommerce_init', [ $this, 'declare_hpos_compat' ] );
	}

	/**
	 * Declare compatibility with HPOS.
	 *
	 * This method checks if the class `FeaturesUtil` from the `Automattic\WooCommerce\Utilities`
	 * namespace exists. If it does, it calls the `declare_compatibility` method of `FeaturesUtil`
	 * class to declare compatibility with the 'custom_order_tables' feature. The second and third
	 * arguments of the `declare_compatibility` method are set to the value of `__FILE__` (the
	 * current file path) and `true` respectively.
	 *
	 * @return void
	 */
	public function declare_hpos_compat(): void {
		if ( class_exists( \Automattic\WooCommerce\Utilities\FeaturesUtil::class ) ) {
			\Automattic\WooCommerce\Utilities\FeaturesUtil::declare_compatibility( 'custom_order_tables',
				WOO_PREVIEW_EMAILS_PRO_FILE, true );
		}
	}
}