<?php

namespace Codemanas\WooPreviewEmailsPro\WooCommerce;

use Codemanas\WooPreviewEmailsPro\Helpers\DependencyManager;

class Membership {
	private static ?Membership $_instance = null;

	public static function get_instance(): ?Membership {
		return ( self::$_instance == null ) ? self::$_instance = new self() : self::$_instance;
	}

	private function __construct() {
		$dependency_manager = DependencyManager::get_instance();
		if ( ! $dependency_manager->is_woocommerce_membership_active() ) {
			return;
		}
		add_filter( 'woo_preview_emails_unset_memebership_emails', array( $this, 'show_membership_emails' ) );
	}

	/**
	 * Show Membership Emails
	 * @return bool
	 */
	public function show_membership_emails(): bool {
		return true;
	}
}