<?php
namespace Codemanas\WooPreviewEmailsPro\WooCommerce;
class Stripe {
	private static ?Stripe $_instance = null;

	public static function get_instance(): ?Stripe {
		return ( self::$_instance == null ) ? self::$_instance = new self() : self::$_instance;
	}

	private function __construct() {
		add_action( 'woo_preview_additional_order_trigger', array( $this, 'trigger' ), 10, 2 );
	}

	/**
	 * Hook action in @woo_preview_additional_orderID
	 *
	 * @param $current_email
	 * @param $data
	 */
	public function trigger( $current_email, $data ) {
		if ( isset( $data['error'] ) ) {
			$msg = $data['error'];
			$msg .= '<p><a href="' . admin_url( 'admin.php?page=codemanas-woocommerce-preview-emails' ) . '">Take me back to choosing emails</a></p>';
			wp_die( $msg );
		}

		if ( in_array( 'WC_Stripe_Email_Failed_Renewal_Authentication', $data ) ) {
			$current_email->trigger( $data[1] );
		}
	}
}